﻿package  {
	import flash.display.Sprite;
	import flash.events.MouseEvent;
	import flash.events.Event;
	import flash.media.Sound;
	import flash.geom.Matrix;
	import flash.text.TextField;
	import flash.utils.Timer;
	import flash.text.TextFormat;
	import flash.events.TimerEvent;
	
	public class HockeyMain extends Sprite {
		var hockeyPaddle:Sprite;
		var hockeyPuck:Sprite;
		var paddleLastX:Number;
		var paddleLastY:Number;
		var puckMomentumX:Number = 0;
		var puckMomentumY:Number = 0;		
		var timeLeft:TextField;
		var currentScore:TextField;
		var levelTimer:Timer;
 		var levelScore:Number = 0;
		var pickupGood:Sprite;
		
		private function addPickupGood(){
			var edgePadding:Number = stage.stageWidth/40;
			pickupGood = new PickupGood() as Sprite;
			pickupGood.x = Math.random() * (stage.stageWidth-edgePadding) + edgePadding;
			pickupGood.y = Math.random() * (stage.stageHeight-edgePadding) + edgePadding;
			this.addChild( pickupGood );
		}
		
		public function HockeyMain() {
			hockeyPaddle = new HockeyPaddle() as Sprite;
			this.addChild(hockeyPaddle);
			hockeyPaddle.mouseEnabled = false;
 
			stage.addEventListener(MouseEvent.MOUSE_DOWN, handleMouseDown, false, 0, true);
			
			hockeyPaddle.x = stage.stageWidth * 0.5;
			hockeyPaddle.y = stage.stageHeight * 0.5;
					 
			hockeyPuck = new HockeyPuck() as Sprite;
			this.addChild(hockeyPuck);
			hockeyPuck.mouseEnabled = false;
			hockeyPuck.x = Math.random()*stage.stageWidth*0.6 + stage.stageWidth*0.2;
			hockeyPuck.y = stage.stageHeight*0.3;
			
			this.addEventListener(Event.ENTER_FRAME, update, false, 0, true); // add this to your constructor!
			
			var pixelPolka:Sound = new PixelPolka() as Sound;
			pixelPolka.play(0, int.MAX_VALUE);
			
			stage.quality = "low";
			hockeyPaddle.cacheAsBitmap = true;
			hockeyPuck.cacheAsBitmap = true;
			hockeyPaddle.cacheAsBitmapMatrix = new Matrix();
			hockeyPuck.cacheAsBitmapMatrix = new Matrix();
			
			if(stage.stageWidth<=320){
				hockeyPaddle.scaleX = 0.5;
				hockeyPaddle.scaleY = 0.5;
				hockeyPuck.scaleX = 0.5;
				hockeyPuck.scaleY = 0.5;
			}
			
			// Add count-down timer textfield
			timeLeft = new TextField();
			timeLeft.text = "30";
			timeLeft.setTextFormat( new TextFormat("Arial", stage.stageWidth * 0.15, 0x777777, "bold") );
			timeLeft.x = stage.stageWidth * 0.8;
			timeLeft.y = 0;
			this.addChild( timeLeft );
			
			currentScore = new TextField();
			currentScore.text = "0";
			currentScore.setTextFormat( new TextFormat("Arial", stage.stageWidth * 0.1, 0x000000, "bold") );
			currentScore.x = stage.stageWidth * 0.8;
			currentScore.y = stage.stageHeight * 0.1;
			this.addChild( currentScore );
			
			levelTimer = new Timer(1000, 30); // repeat every 1000 milliseconds (1 second), 30 times (30 seconds)
			levelTimer.addEventListener(TimerEvent.TIMER_COMPLETE, levelComplete, false, 0, true);
			levelTimer.addEventListener(TimerEvent.TIMER, updateLevelTimer, false, 0, true);
			levelTimer.start(); // timers have to be told to start, they don't start automatically
			
			addPickupGood();
			
		}
 
		private function handleMouseDown(e:MouseEvent) {
			hockeyPaddle.x = e.target.mouseX;
			hockeyPaddle.y = e.target.mouseY;
			stage.addEventListener(MouseEvent.MOUSE_MOVE, handleMouseMove, false, 0, true);
			stage.addEventListener(MouseEvent.MOUSE_UP, handleMouseUp, false, 0, true);
		}
 
		private function handleMouseMove(e:MouseEvent) {
			hockeyPaddle.x = e.target.mouseX;
			hockeyPaddle.y = e.target.mouseY;
		}
 
		private function handleMouseUp(e:MouseEvent) {
			stage.removeEventListener(MouseEvent.MOUSE_MOVE, handleMouseMove);
			stage.removeEventListener(MouseEvent.MOUSE_UP, handleMouseUp);
		}
		
		private function update(e:Event){
			
			var diffFromPuckX:Number = hockeyPaddle.x-hockeyPuck.x;
			var diffFromPuckY:Number = hockeyPaddle.y-hockeyPuck.y;
			
			var distanceFromPuck:Number = Math.sqrt( Math.pow(diffFromPuckX, 2) + Math.pow(diffFromPuckY, 2) );
			
			if(distanceFromPuck <= (hockeyPaddle.width/2 + hockeyPuck.width/2)){
				var diffX:Number = hockeyPaddle.x - paddleLastX;
				var diffY:Number = hockeyPaddle.y - paddleLastY;
				var angleFromPuck:Number = Math.atan2(diffFromPuckY, diffFromPuckX);
				puckMomentumX = - Math.cos(angleFromPuck) * 20;
				puckMomentumY = - Math.sin(angleFromPuck) * 20;
				
				var puckRicochet:Sound = new PuckRicochet() as Sound;
				puckRicochet.play();
			}
			hockeyPuck.x += puckMomentumX;
			hockeyPuck.y += puckMomentumY;
				 
			var edgePadding:Number = stage.stageWidth/40;
			// check if too far left
			if(hockeyPuck.x - hockeyPuck.width/2 - edgePadding < 0){
				puckMomentumX = -puckMomentumX;
				hockeyPuck.x = edgePadding + hockeyPuck.width/2; // sets the puck to the edge of the screen
			}
			// check if too far right
			if(hockeyPuck.x + hockeyPuck.width/2 + edgePadding > stage.stageWidth){
				puckMomentumX = -puckMomentumX;
				hockeyPuck.x = stage.stageWidth - edgePadding - hockeyPuck.width/2;
			}
			// check if too far up
			if(hockeyPuck.y - hockeyPuck.height/2 - edgePadding < 0){
				puckMomentumY = -puckMomentumY;
				hockeyPuck.y = edgePadding +  hockeyPuck.height/2;
			}
			// check if too low
			if(hockeyPuck.y + hockeyPuck.height/2 + edgePadding > stage.stageHeight){
				puckMomentumY = -puckMomentumY;
				hockeyPuck.y = stage.stageHeight - edgePadding -  hockeyPuck.height/2;
			}
				 
			// Apply Friction, a low amount
			puckMomentumX *= 0.995;
			puckMomentumY *= 0.995;
				 
			paddleLastX = hockeyPaddle.x;
			paddleLastY = hockeyPaddle.y;
			
			// Hit detection for pickups
			if( hockeyPuck.hitTestObject( pickupGood ) ){
				// increase the score
				levelScore++;
				currentScore.text = String(levelScore);
				currentScore.setTextFormat( new TextFormat("Arial", stage.stageWidth * 0.1, 0x000000, "bold") );
						 
				// remove this pickup from the screen
				this.removeChild( pickupGood );
				pickupGood = null;
						 
				// add a new pickup
				addPickupGood();
			}
		}
		
		private function updateLevelTimer(e:Event){
			timeLeft.text = String(Number(timeLeft.text) - 1); // subtract one from current time
			timeLeft.setTextFormat( new TextFormat("Arial", stage.stageWidth * 0.15, 0x777777, "bold") );
		}
		
		private function levelComplete(e:Event){
			levelTimer.removeEventListener(TimerEvent.TIMER_COMPLETE, levelComplete);
			levelTimer.removeEventListener(TimerEvent.TIMER, updateLevelTimer);
		
			var completeMessage:TextField = new TextField();
			completeMessage.width = stage.stageWidth;
			completeMessage.multiline = true;
			completeMessage.text = "Level Complete!\nYour Score:"+levelScore;
			var textFormat:TextFormat = new TextFormat("Arial", stage.stageWidth * 0.1, 0x00CCFF, "bold");
			textFormat.align = "center"; // this center aligns the text
			completeMessage.setTextFormat( textFormat );
			completeMessage.y = stage.stageHeight*0.5 - completeMessage.textHeight/2;// to center the textfield I am subtracting half of the height of the text field's content
			this.addChild( completeMessage );
				 
			this.removeEventListener(Event.ENTER_FRAME, update);
		}
	}
}